package com.fp.persistence.pbpm.gene;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TBPMPROCESSVARIABLES*/
@Embeddable
public class TbpmProcessVariablesKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="JOURNALID", nullable=false,updatable=false)

/**
* Numero de mensaje asociado al a instacioa del flujo.
*/
private String journalid;

@Column(name="NAME", nullable=false,updatable=false)

/**
* Nombre de la Variable
*/
private String name;

/**Contructor por defecto*/
public TbpmProcessVariablesKey(){}
/**Contructor de TbpmProcessVariablesKey
@param pJournalid Numero de mensaje asociado al a instacioa del flujo.
@param pName Nombre de la Variable
*/
public TbpmProcessVariablesKey(String pJournalid,String pName){
 journalid=pJournalid;
 name=pName;
}
/**Obtiene el valor de journalid
@return valor de journalid*/
public String getJournalid(){
  return journalid;
}
/**Fija el valor de journalid
@param pJournalid nuevo Valor de journalid*/
public void setJournalid(String pJournalid){
  journalid=pJournalid;
}

/**Obtiene el valor de name
@return valor de name*/
public String getName(){
  return name;
}
/**Fija el valor de name
@param pName nuevo Valor de name*/
public void setName(String pName){
  name=pName;
}

/**Implementacion de la comparacion de TbpmProcessVariablesKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TbpmProcessVariablesKey))return false;
  TbpmProcessVariablesKey that = (TbpmProcessVariablesKey) o;
  if (this.getJournalid() == null || that.getJournalid() == null){
      return false;
  }
  if (! this.getJournalid().equals(that.getJournalid())){
    return false;
  }
  if (this.getName() == null || that.getName() == null){
      return false;
  }
  if (! this.getName().equals(that.getName())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TbpmProcessVariablesKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getJournalid() == null ? 0 : this.getJournalid().hashCode());
    result = result * 37 + (this.getName() == null ? 0 : this.getName().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
